//+------------------------------------------------------------------+
//|                                                  GSMinformer.mq5 |
//|                                         Copyright 2013, Decanium |
//|                                          http://www.decanium.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2013, Decanium"
#property link      "http://www.decanium.com"
#property version   "1.00"
//---
#include <modem.mqh>
//--- input parameters
input string         str00="===  COM- ====";
input ComPortList    inp_com_port_index=COM3;    //  COM-
input BaudRateList   inp_com_baudrate=_9600bps;  //  
//---
input string         str01="=======  ==============";
input int            inp_refr_period=3;          //   , 
input int            inp_ussd_request_tout=20;   //     ussd-, 
input string         inp_sms_service_center="";  //  - 
//---
input string         str02="===   ======";
input int            inp_refr_bal_period=12;     //  , 
input string         inp_ussd_get_balance="";    // USSD- 
input string         inp_ussd_bal_suffix="";     //  
input string         inp_ussd_exp_prefix="";     //      
//---
input string         str03="=    ==";
input int            inp_refr_smscnt_period=6;   //  , 
input string         inp_ussd_get_sms_cnt="";    // USSD-   
input string         inp_ussd_sms_suffix="";     //   
input int            inp_free_sms_daily=0;       //   
//---
input string         str04="============================";
input string         inp_admin_number="";        //   
input int            inp_conn_hyst=6;            // , 10 
input int            inp_sms_max_old=600;        //   -, 

bool sms_mem_full=false;
//+------------------------------------------------------------------+
//| IncomingSMS                                                      |
//|     -                    |
//+------------------------------------------------------------------+
void IncomingSMS(INCOMING_SMS_STR &sms)
  {
   string str,strtmp;
//---     SMS-:
   ObjectSetString(0,"str18",OBJPROP_TEXT,"SMS number:      "+sms.sender);
//---       SMS-:
   str=TimeToString(sms.scts.time,TIME_DATE|TIME_SECONDS);
   ObjectSetString(0,"str19",OBJPROP_TEXT,"SMS date/time:   "+str);
//---    SMS-:
   strtmp=StringSubstr(sms.text,0,32); str=" ";
   if(strtmp!="") str=strtmp;
   ObjectSetString(0,"str20",OBJPROP_TEXT,str);
   strtmp=StringSubstr(sms.text,32,32); str=" ";
   if(strtmp!="") str=strtmp;
   ObjectSetString(0,"str21",OBJPROP_TEXT,str);
   strtmp=StringSubstr(sms.text,64,32); str=" ";
   if(strtmp!="") str=strtmp;
   ObjectSetString(0,"str22",OBJPROP_TEXT,str);
   strtmp=StringSubstr(sms.text,96,32); str=" ";
   if(strtmp!="") str=strtmp;
   ObjectSetString(0,"str23",OBJPROP_TEXT,str);
   strtmp=StringSubstr(sms.text,128,32); str=" ";
   if(strtmp!="") str=strtmp;
   ObjectSetString(0,"str24",OBJPROP_TEXT,str);
//
   if(sms.sender==inp_admin_number)
     {
      Print("  ");
      datetime t=TimeLocal();
      if(t-sms.scts.time<=inp_sms_max_old)
        {
         //Print("c   "+DoubleToString(t-sms.scts.time,0)+"");
         //--- ,  ,  
         string cmdstr=sms.text;
         StringToUpper(cmdstr);
         //Print(cmdstr);
         int pos= StringFind(cmdstr,"CLOSE",0);
         cmdstr = StringSubstr(cmdstr, pos+6, 6);
         if(pos>=0)
           {//--- .   
            ClosePositions(cmdstr);
           }
        }
      else
         Print("- ");
     }
  }
//+------------------------------------------------------------------+
//| ClosePositions                                                   |
//|                                         |
//+------------------------------------------------------------------+
uint ClosePositions(string sstr)
  {
   bool all=false;
   if(StringFind(sstr,"ALL",0)>=0)
      all=true;
//Print(" "+sstr);
   uint res = 0;
   for(int i=0;i<PositionsTotal();i++)
     {
      string symbol=PositionGetSymbol(i);
      if(all==true || sstr==symbol)
        {
         if(PositionSelect(symbol)==true)
           {
            long pos_type;
            double pos_vol;
            if(PositionGetInteger(POSITION_TYPE,pos_type)==true)
              {
               if(PositionGetDouble(POSITION_VOLUME,pos_vol)==true)
                 {
                  if(OrderClose(symbol,(ENUM_POSITION_TYPE)pos_type,pos_vol)==true)
                     res|=0x01;
                  else
                     res|=0x02;
                 }
              }
           }
        }
     }
   return(res);
  }
//+------------------------------------------------------------------+
//| OrderClose                                                       |
//+------------------------------------------------------------------+
bool OrderClose(string symbol,ENUM_POSITION_TYPE pos_type,double vol)
  {
//
//Print("CLOSE");
//
   MqlTick last_tick;
   MqlTradeRequest request;
   MqlTradeResult result;
   double price=0;
//
   ZeroMemory(request);
   ZeroMemory(result);
//
   if(SymbolInfoTick(Symbol(),last_tick))
     {
      price=last_tick.bid;
     }
   else
     {
      Print("   ");
      return(false);
     }
//   
   if(pos_type==POSITION_TYPE_BUY)
     {
      //---   BUY - (SELL)
      request.type=ORDER_TYPE_SELL;
     }
   else if(pos_type==POSITION_TYPE_SELL)
     {
      //---   SELL - (BUY)
      request.type=ORDER_TYPE_BUY;
     }
   else
      return(false);
//
   request.price=NormalizeDouble(price,_Digits);
   request.deviation=20;
   request.action = TRADE_ACTION_DEAL;
   request.symbol = symbol;
   request.volume = NormalizeDouble(vol, 2);
   if(request.volume==0)
      return(false);
   request.type_filling=ORDER_FILLING_FOK;
//
   if(OrderSend(request,result)==true)
     {
      if(result.retcode==TRADE_RETCODE_DONE || result.retcode==TRADE_RETCODE_DONE_PARTIAL)
        {
         Print("  ");
         return(true);
        }
     }
   else
     {
      Print("  : ",GetLastError(),",    : ",result.retcode);
      return(false);
     }
//
   return(false);
  }
//+------------------------------------------------------------------+
//| SMSMemoryFull                                                    |
//|  SMS                                            |
//+------------------------------------------------------------------+
void SMSMemoryFull(int n)
  {
   sms_mem_full=true;
   for(int i=0; i<n; i++)
     {//---   SMS-
      if(DelSMSbyIndex(i)==false)
         break;
      else
         sms_mem_full=false;
     }
  }
//+------------------------------------------------------------------+
//| IncomingCall                                                     |
//|                           |
//+------------------------------------------------------------------+
void IncomingCall(string number)
  {//
//Print("Incoming Call: "+number);
   bool result;
   if(number==inp_admin_number)
     {
      Print(" .  .");
      //
      string mob_bal="";
      //---   
      if(modem.bal!=-10000)
         mob_bal="\n(m.bal="+DoubleToString(modem.bal,2)+")";
      result=SendSMS(inp_admin_number,//"Server: " +AccountInfoString(ACCOUNT_SERVER)
                     "Account: "+DoubleToString(AccountInfoInteger(ACCOUNT_LOGIN),0)
                     +"\nProfit: "+DoubleToString(AccountInfoDouble(ACCOUNT_PROFIT),2)
                     +"\nEquity: "+DoubleToString(AccountInfoDouble(ACCOUNT_EQUITY),2)
                     +"\nPositions: "+DoubleToString(PositionsTotal(),0)
                     +mob_bal
                     ,false);
      if(result==true)
         Print("SMS  ");
      else
         Print("  SMS");
     }
   else
      Print("  ("+number+")");
//---     :
   ObjectSetString(0,"str16",OBJPROP_TEXT,"Incoming:        "+number);
  }
//+------------------------------------------------------------------+
//| ModemChState                                                     |
//+------------------------------------------------------------------+
void ModemChState()
  {
   static bool init_ok=false;
//Print("  ");
   if(modem.init_ok==true && init_ok==false)
     {
      Print("   ");
      init_ok=true;
     }
//---
   RefreshTab();
  }
//+------------------------------------------------------------------+
//| TextXY                                                           |
//+------------------------------------------------------------------+
void TextXY(string ObjName,string Text,int x,int y,color TextColor)
  {
//---   
   ObjectDelete(0,ObjName);
   ObjectCreate(0,ObjName,OBJ_LABEL,0,0,0,0,0);
   ObjectSetInteger(0,ObjName,OBJPROP_XDISTANCE,x);
   ObjectSetInteger(0,ObjName,OBJPROP_YDISTANCE,y);
   ObjectSetInteger(0,ObjName,OBJPROP_COLOR,TextColor);
   ObjectSetInteger(0,ObjName,OBJPROP_FONTSIZE,9);
   ObjectSetString(0,ObjName,OBJPROP_FONT,"Courier New");
   ObjectSetString(0,ObjName,OBJPROP_TEXT,Text);
  }
//+------------------------------------------------------------------+
//| DrawTab                                                          |
//|                                     |
//+------------------------------------------------------------------+
void DrawTab()
  {
   int   x=20, //   
   y = 20,     //  
   dy = 15;    //  
//---  
   ObjectDelete(0,"bgnd000");
   ObjectCreate(0,"bgnd000",OBJ_RECTANGLE_LABEL,0,0,0,0,0);
   ObjectSetInteger(0,"bgnd000",OBJPROP_XDISTANCE,x-10);
   ObjectSetInteger(0,"bgnd000",OBJPROP_YDISTANCE,y-5);
   ObjectSetInteger(0,"bgnd000",OBJPROP_XSIZE,270);
   ObjectSetInteger(0,"bgnd000",OBJPROP_YSIZE,420);
   ObjectSetInteger(0,"bgnd000",OBJPROP_BGCOLOR,clrBlack);
//---  
   TextXY("str0",  "Port:            ", x, y, clrWhite); y+=dy;
   TextXY("str1",  "Speed:           ", x, y, clrWhite); y+=dy;
   TextXY("str2",  "Rx:              ", x, y, clrWhite); y+=dy;
   TextXY("str3",  "Tx:              ", x, y, clrWhite); y+=dy;
   TextXY("str4",  "Err:             ", x, y, clrWhite); y+=(dy*3)/2;
//---  
   TextXY("str5",  "Modem:           ", x, y, clrWhite); y+=dy;
   TextXY("str6",  "SIM:             ", x, y, clrWhite); y+=dy;
   TextXY("str7",  "NET:             ", x, y, clrWhite); y+=dy;
   TextXY("str8",  "Operator:        ", x, y, clrWhite); y+=dy;
   TextXY("str9",  "SMSC:            ", x, y, clrWhite); y+=dy;
   TextXY("str10", "RSSI:            ", x, y, clrWhite); y+=dy;
   TextXY("str11", "Bat:             ", x, y, clrWhite); y+=dy;
   TextXY("str12", "Modem status:    ", x, y, clrWhite); y+=(dy*3)/2;
//---   
   TextXY("str13", "Balance:         ", x, y, clrWhite); y+=dy;
   TextXY("str14", "Expiration date: ", x, y, clrWhite); y+=dy;
   TextXY("str15", "Free SMS:        ", x, y, clrWhite); y+=(dy*3)/2;
//---    
   TextXY("str16","Incoming:        ",x,y,clrWhite); y+=(dy*3)/2;
//---    SMS-
   TextXY("str17", "SMS mem full:    ", x, y, clrWhite); y+=dy;
   TextXY("str18", "SMS number:      ", x, y, clrWhite); y+=dy;
   TextXY("str19", "SMS date/time:   ", x, y, clrWhite); y+=dy;
//---    SMS-
   TextXY("str20", "                 ", x, y, clrGray); y+=dy;
   TextXY("str21", "                 ", x, y, clrGray); y+=dy;
   TextXY("str22", "                 ", x, y, clrGray); y+=dy;
   TextXY("str23", "                 ", x, y, clrGray); y+=dy;
   TextXY("str24", "                 ", x, y, clrGray); y+=dy;
//---
   ChartRedraw(0);
  }
//+------------------------------------------------------------------+
//| RefreshTab()                                                     |
//|                                         |
//+------------------------------------------------------------------+
void RefreshTab()
  {
   string str;
//---  COM-:
   str="COM"+DoubleToString(PortID+1,0);
   ObjectSetString(0,"str0",OBJPROP_TEXT,"Port:            "+str);
//---  :
   str=DoubleToString(inp_com_baudrate,0)+" bps";
   ObjectSetString(0,"str1",OBJPROP_TEXT,"Speed:           "+str);
//---   :
   str=DoubleToString(rx_cnt,0)+" bytes";
   ObjectSetString(0,"str2",OBJPROP_TEXT,"Rx:              "+str);
//---   :
   str=DoubleToString(tx_cnt,0)+" bytes";
   ObjectSetString(0,"str3",OBJPROP_TEXT,"Tx:              "+str);
//---     :
   str=DoubleToString(tx_err,0);
   ObjectSetString(0,"str4",OBJPROP_TEXT,"Err:             "+str);
//---    :
   str=modem.manufacturer+" "+modem.device;
   ObjectSetString(0,"str5",OBJPROP_TEXT,"Modem:           "+str);
//---  SIM-:
   string sim_stat_str[2]={"Error","Ok"};
   if(modem.sim_stat==-1)
      str="n/a";
   else
      str=sim_stat_str[modem.sim_stat];
   ObjectSetString(0,"str6",OBJPROP_TEXT,"SIM:             "+str);
//---   :
   string net_reg_str[6]={"No","Ok","Search...","Restricted","Unknown","Roaming"};
   if(modem.net_reg==-1)
      str="n/a";
   else
      str=net_reg_str[modem.net_reg];
   ObjectSetString(0,"str7",OBJPROP_TEXT,"NET:             "+str);
//---    :
   ObjectSetString(0,"str8",OBJPROP_TEXT,"Operator:        "+modem.op);
//---  - SMS
   ObjectSetString(0,"str9",OBJPROP_TEXT,"SMSC:            "+modem.sms_sca);
//---  :
   if(modem.rssi==-1)
      str="n/a";
   else
      str=rssi_to_str(modem.rssi);
   ObjectSetString(0,"str10",OBJPROP_TEXT,"RSSI:            "+str);
//---   (  ):
   string bat_stats_str[4]={"Ok, ","Ok, ","No","Err"};
   if(modem.bat_stat==-1)
      str="n/a";
   else
      str=bat_stats_str[modem.bat_stat];
   if(modem.bat_stat==0 || modem.bat_stat==1)
      str+=DoubleToString(modem.bat_charge,0)+"%";
   ObjectSetString(0,"str11",OBJPROP_TEXT,"Bat:             "+str);
//---  :
   string modem_stat_str[5]={"Ready","Err","Err","Incoming call","Active call"};
   if(modem.status==-1)
      str="init...";
   else
     {
      if(modem.status>4 || modem.status<0)
         Print("Unknown modem status: "+DoubleToString(modem.status,0));
      else
         str=modem_stat_str[modem.status];
     }
   ObjectSetString(0,"str12",OBJPROP_TEXT,"Modem status:    "+str);
//---   :
   if(modem.bal==-10000)
      str="n/a";
   else
      str=DoubleToString(modem.bal,2)+" "+inp_ussd_bal_suffix;
   ObjectSetString(0,"str13",OBJPROP_TEXT,"Balance:         "+str);
//---    :
   ObjectSetString(0,"str14",OBJPROP_TEXT,"Expiration date: "+modem.exp_date);
//---   SMS-:
   if(modem.sms_free<0)
      str="n/a";
   else
      str=DoubleToString(modem.sms_free,0);
   ObjectSetString(0,"str15",OBJPROP_TEXT,"Free SMS:        "+str);
//---   SMS-:
   if(sms_mem_full==true)
      str="Yes";
   else
      str="No";
   ObjectSetString(0,"str17",OBJPROP_TEXT,"SMS mem full:    "+str);
//---
   ChartRedraw(0);
  }
//+------------------------------------------------------------------+
//| DelTab                                                           |
//|                                                    |
//+------------------------------------------------------------------+
void DelTab()
  {
   for(int i=0; i<25; i++)
      ObjectDelete(0,"str"+DoubleToString(i,0));
   ObjectDelete(0,"bgnd000");
  }
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---  COM-
   if(InitComPort()==false)
     {
      Print("   COM"+DoubleToString(inp_com_port_index+1,0));
      return(INIT_FAILED);
     }
//---
   DrawTab();
//---  
   InitModem();
//---   
   EventSetTimer(1);// 1 
//---
   RefreshTab();
//---
   conn_mon_init();
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//--- destroy timer
   EventKillTimer();
   DeinitComPort();
   DelTab();
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
  }
//
//+------------------------------------------------------------------+
//| POS_STR                                                          |
//+------------------------------------------------------------------+
struct POS_STR
  {
   bool              new_event;
   string            symbol;
   ulong             deal;
   ENUM_DEAL_TYPE    deal_type;
   double            volume;
   double            price;
  };

#define POS_BUF_LEN  3

POS_STR ps[POS_BUF_LEN];
//  

//+------------------------------------------------------------------+
//|                              |
//+------------------------------------------------------------------+
struct CONN_MON_STR
  {
   bool              new_state;    //   
   bool              connected;    // 
   int               conn_cnt;     //   
   int               disconn_cnt;  //   
   datetime          conn_time;    //  
   datetime          disconn_time; //  
  };

CONN_MON_STR cm;//    
//+------------------------------------------------------------------+
//| conn_mon_init                                                    |
//+------------------------------------------------------------------+
void conn_mon_init()
  {
   cm.connected= true;
   cm.conn_cnt = inp_conn_hyst;
   cm.disconn_cnt=0;
   cm.conn_time = TimeLocal();
   cm.new_state = false;
  }
//+------------------------------------------------------------------+
//| Timer function                                                   |
//+------------------------------------------------------------------+
void OnTimer()
  {
//---
   ModemTimerProc();//  
                    //
   static int s10=0;//  10 
   static datetime conn_time;
   static datetime disconn_time;
   if(++s10>=10)
     {//  10 
      s10=0;
      //
      if((bool)TerminalInfoInteger(TERMINAL_CONNECTED)==true)
        {
         if(cm.conn_cnt==0)             //    
            conn_time = TimeLocal();    // 
         if(cm.conn_cnt<inp_conn_hyst)
           {
            if(++cm.conn_cnt>=inp_conn_hyst)
              {
               //---  
               if(cm.connected==false)
                 {
                  //---       
                  cm.connected = true;
                  cm.new_state = true;
                  cm.conn_time = conn_time;
                 }
              }
           }
         //Print("Connected");
         cm.disconn_cnt=0;
        }
      else
        {
         if(cm.disconn_cnt==0)          //    
            disconn_time = TimeLocal(); // 
         if(cm.disconn_cnt<inp_conn_hyst)
           {
            //---   
            if(++cm.disconn_cnt>=inp_conn_hyst)
              {
               //---       
               if(cm.connected==true)
                 {
                  cm.connected = false;
                  cm.new_state = true;
                  cm.disconn_time=disconn_time;
                 }
              }
           }
         //Print("Disconnected");   
         cm.conn_cnt=0;
        }
      //
     }
//
//---   
   if(cm.new_state==true)
     {
      if(cm.connected==true)
        {//---  
         string str="Connected "+TimeToString(cm.conn_time,TIME_DATE|TIME_SECONDS);
         if(cm.disconn_time!=0)
            str+=", offline: "+dTimeToString((ulong)(cm.conn_time-cm.disconn_time));
         Print(str);
         SendSMS(inp_admin_number,str,false);// 
        }
      else
        {//---  
         string str="Disconnected "+TimeToString(cm.disconn_time,TIME_DATE|TIME_SECONDS);
         if(cm.conn_time!=0)
            str+=", online: "+dTimeToString((ulong)(cm.disconn_time-cm.conn_time));
         Print(str);
         SendSMS(inp_admin_number,str,false);// 
        }
      cm.new_state=false;
     }
//---  - 
   string posstr="";
   for(int i=0;i<POS_BUF_LEN;i++)
     {
      if(ps[i].new_event==true)
        {
         string str;
         if(ps[i].deal_type==DEAL_TYPE_BUY)
            str+="Buy ";
         else if(ps[i].deal_type==DEAL_TYPE_SELL)
            str+="Sell ";
         str+=DoubleToString(ps[i].volume,2)+" "+ps[i].symbol;
         int digits=(int)SymbolInfoInteger(ps[i].symbol,SYMBOL_DIGITS);
         str+=", price="+DoubleToString(ps[i].price,digits);
         //
         long deal_entry;
         HistorySelect(TimeCurrent()-3600,TimeCurrent());//    
         if(HistoryDealGetInteger(ps[i].deal,DEAL_ENTRY,deal_entry)==true)
           {
            if(((ENUM_DEAL_ENTRY)deal_entry)==DEAL_ENTRY_IN)
               str+=", entry: in";
            else if(((ENUM_DEAL_ENTRY)deal_entry)==DEAL_ENTRY_OUT)
              {
               str+=", entry: out";
               double profit;
               if(HistoryDealGetDouble(ps[i].deal,DEAL_PROFIT,profit)==true)
                 {
                  str+=", profit = "+DoubleToString(profit,2);
                 }
              }
           }
         posstr+=str+"\r\n";
         ps[i].new_event=false;
        }
     }
   if(posstr!="")
     {
      Print(posstr+"pos: "+DoubleToString(PositionsTotal(),0));
      SendSMS(inp_admin_number,posstr+"pos: "+DoubleToString(PositionsTotal(),0),false);
     }
//
  }
//+------------------------------------------------------------------+
//| dTimeToString                                                    |
//+------------------------------------------------------------------+
string dTimeToString(ulong sec)
  {
   string str;
   uint days=(uint)(sec/86400);
   if(days>0)
     {
      str+= DoubleToString(days,0)+" days, ";
      sec-= days*86400;
     }
   uint hour=(uint)(sec/3600);
   if(hour<10) str+="0";
   str+= DoubleToString(hour,0)+":";
   sec-= hour*3600;
   uint min=(uint)(sec/60);
   if(min<10) str+="0";
   str+= DoubleToString(min,0)+":";
   sec-= min*60;
   if(sec<10) str+="0";
   str+=DoubleToString(sec,0);
//
   return(str);
  }
//+------------------------------------------------------------------+
//| TradeTransaction function                                        |
//+------------------------------------------------------------------+
void OnTradeTransaction(const MqlTradeTransaction &trans,
                        const MqlTradeRequest &request,
                        const MqlTradeResult &result)
  {
//---
   if(trans.type==TRADE_TRANSACTION_DEAL_ADD)
     {
      if(trans.deal_type==DEAL_TYPE_BUY ||
         trans.deal_type==DEAL_TYPE_SELL)
        {
         int i;
         for(i=0;i<POS_BUF_LEN;i++)
           {
            if(ps[i].new_event==false)
               break;
           }
         if(i<POS_BUF_LEN)
           {
            ps[i].new_event = true;
            ps[i].deal_type = trans.deal_type;
            ps[i].symbol = trans.symbol;
            ps[i].volume = trans.volume;
            ps[i].price= trans.price;
            ps[i].deal = trans.deal;
           }
        }
     }
//   
  }
//+------------------------------------------------------------------+
